﻿namespace core.Collision_Converter
{
    using core;
    using core.H1;
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;

    public class CollisionConverter : Form
    {
        private IContainer components;
        private CompiledTagInterface h1bsp;
        private TreeView treeView1;

        public CollisionConverter(int tagnumber, Map h1map)
        {
            this.InitializeComponent();
            this.h1bsp = new CompiledTagInterface(tagnumber, h1map);
            this.PopulateTreeView();
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.treeView1 = new TreeView();
            base.SuspendLayout();
            this.treeView1.Location = new Point(12, 12);
            this.treeView1.Name = "treeView1";
            this.treeView1.Size = new Size(0x121, 0xf2);
            this.treeView1.TabIndex = 0;
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            base.ClientSize = new Size(0x25e, 0x10a);
            base.Controls.Add(this.treeView1);
            base.Name = "CollisionConverter";
            this.Text = "CollisionConverter";
            base.ResumeLayout(false);
        }

        private void PopulateTreeView()
        {
            coll chunk = (coll) this.h1bsp.Header.GetChunk(0);
            foreach (coll.Region region in chunk.regions.Chunks)
            {
                TreeNode node = new TreeNode(region.name.Value);
                foreach (coll.Region.Permutation permutation in region.permutations.Chunks)
                {
                    node.Nodes.Add(new TreeNode(permutation.name.Value));
                }
                this.treeView1.Nodes.Add(node);
            }
        }
    }
}

