﻿namespace core
{
    using core.Builder;
    using core.Collision_Converter;
    using core.H1.tagconverter;
    using core.H2;
    using core.IO;
    using core.Rebuilder;
    using ObjectRelocator;
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;
    using TD.SandBar;
    using TD.SandDock;
    using TD.SandDock.Rendering;

    public class HaloForm : Form
    {
        private DockContainer bottomSandDock;
        private ContextMenuStrip collConvertContext;
        private IContainer components;
        private ToolStripMenuItem convertSBSPCollisionToolStripMenuItem;
        private ToolStripMenuItem decompileAsToolStripMenuItem;
        private DockControl dockControl1;
        private DockControl dockControl2;
        private DockControl dockControl3;
        private DockControl dockControl4;
        private DockControl dockControl6;
        private DocumentContainer documentContainer1;
        private FormFunctions ff = new FormFunctions();
        private DockContainer leftSandDock;
        private Map map;
        private MenuBar menuBar1;
        private MenuBarItem menuBarItem1;
        private MenuBarItem menuBarItem2;
        private MenuBarItem menuBarItem3;
        private MenuBarItem menuBarItem4;
        private MenuButtonItem menuButtonItem1;
        private MenuButtonItem menuButtonItem10;
        private MenuButtonItem menuButtonItem11;
        private MenuButtonItem menuButtonItem12;
        private MenuButtonItem menuButtonItem13;
        private MenuButtonItem menuButtonItem14;
        private MenuButtonItem menuButtonItem15;
        private MenuButtonItem menuButtonItem2;
        private MenuButtonItem menuButtonItem3;
        private MenuButtonItem menuButtonItem4;
        private MenuButtonItem menuButtonItem5;
        private MenuButtonItem menuButtonItem6;
        private MenuButtonItem menuButtonItem7;
        private MenuButtonItem menuButtonItem8;
        private MenuButtonItem menuButtonItem9;
        private PropertyGrid MetaGrid;
        private TreeView MetaTree;
        private ContextMenuStrip metaTreeContext;
        private FormFunctions.MetaView metatreedisplaytype = FormFunctions.MetaView.TagTypeView;
        private MenuButtonItem objectrelocator;
        private OpenFileDialog OpenHaloMapDialog;
        private ToolStripMenuItem openMetaInSeperateTabToolStripMenuItem;
        private ProgramSettings ps = new ProgramSettings();
        private RichTextBox richTextBox1;
        private DockContainer rightSandDock;
        private SandDockManager sandDockManager1;
        private ContextMenuStrip sbspConvertContext;
        private Meta selectedMeta;
        private StatusStrip statusStrip1;
        private int tagnumber;
        private ToolStripMenuItem toolStripMenuItem1;
        private DockContainer topSandDock;

        public HaloForm()
        {
            this.InitializeComponent();
            Tag_Layouts.Layouts = new Tag_Layouts();
        }

        public void AddMetasToTreeview()
        {
            switch (this.metatreedisplaytype)
            {
                case FormFunctions.MetaView.FolderView:
                    this.ff.AddMetaByFolderToTreeView(ref this.map, ref this.MetaTree, false);
                    return;

                case FormFunctions.MetaView.TagTypeView:
                    this.ff.AddMetaByTagTypeToTreeView(ref this.map, ref this.MetaTree, false);
                    return;
            }
        }

        private void convertSBSPCollisionToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Choose an H2 Map");
            if (this.OpenHaloMapDialog.ShowDialog() != DialogResult.Cancel)
            {
                Map map = new Map(this.OpenHaloMapDialog.FileName);
                if (map.HaloVersion != Map.HaloVersionEnum.Halo2)
                {
                    MessageBox.Show("Choose an H2 Map");
                }
                else
                {
                    BSPConvert.Convert(this.map, map);
                }
            }
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void dockControl2_Closing(object sender, CancelEventArgs e)
        {
        }

        private void InitializeComponent()
        {
            this.components = new Container();
            this.OpenHaloMapDialog = new OpenFileDialog();
            this.MetaTree = new TreeView();
            this.metaTreeContext = new ContextMenuStrip(this.components);
            this.openMetaInSeperateTabToolStripMenuItem = new ToolStripMenuItem();
            this.MetaGrid = new PropertyGrid();
            this.sbspConvertContext = new ContextMenuStrip(this.components);
            this.convertSBSPCollisionToolStripMenuItem = new ToolStripMenuItem();
            this.collConvertContext = new ContextMenuStrip(this.components);
            this.toolStripMenuItem1 = new ToolStripMenuItem();
            this.sandDockManager1 = new SandDockManager();
            this.leftSandDock = new DockContainer();
            this.dockControl1 = new DockControl();
            this.rightSandDock = new DockContainer();
            this.bottomSandDock = new DockContainer();
            this.dockControl2 = new DockControl();
            this.richTextBox1 = new RichTextBox();
            this.topSandDock = new DockContainer();
            this.menuBar1 = new MenuBar();
            this.menuBarItem1 = new MenuBarItem();
            this.menuButtonItem1 = new MenuButtonItem();
            this.menuBarItem2 = new MenuBarItem();
            this.menuButtonItem2 = new MenuButtonItem();
            this.menuButtonItem3 = new MenuButtonItem();
            this.menuButtonItem4 = new MenuButtonItem();
            this.menuBarItem3 = new MenuBarItem();
            this.menuButtonItem6 = new MenuButtonItem();
            this.menuButtonItem7 = new MenuButtonItem();
            this.menuButtonItem8 = new MenuButtonItem();
            this.menuButtonItem9 = new MenuButtonItem();
            this.menuButtonItem10 = new MenuButtonItem();
            this.menuButtonItem11 = new MenuButtonItem();
            this.menuButtonItem14 = new MenuButtonItem();
            this.menuBarItem4 = new MenuBarItem();
            this.menuButtonItem12 = new MenuButtonItem();
            this.menuButtonItem13 = new MenuButtonItem();
            this.menuButtonItem5 = new MenuButtonItem();
            this.menuButtonItem15 = new MenuButtonItem();
            this.objectrelocator = new MenuButtonItem();
            this.documentContainer1 = new DocumentContainer();
            this.dockControl3 = new DockControl();
            this.dockControl6 = new DockControl();
            this.dockControl4 = new DockControl();
            this.statusStrip1 = new StatusStrip();
            this.metaTreeContext.SuspendLayout();
            this.sbspConvertContext.SuspendLayout();
            this.collConvertContext.SuspendLayout();
            this.leftSandDock.SuspendLayout();
            this.dockControl1.SuspendLayout();
            this.bottomSandDock.SuspendLayout();
            this.dockControl2.SuspendLayout();
            this.documentContainer1.SuspendLayout();
            this.dockControl3.SuspendLayout();
            this.dockControl4.SuspendLayout();
            base.SuspendLayout();
            this.OpenHaloMapDialog.Filter = "Map (*.map) | *.map";
            this.MetaTree.ContextMenuStrip = this.metaTreeContext;
            this.MetaTree.Dock = DockStyle.Fill;
            this.MetaTree.Location = new Point(0, 0);
            this.MetaTree.Name = "MetaTree";
            this.MetaTree.Size = new Size(0x1e2, 0x1a0);
            this.MetaTree.TabIndex = 5;
            this.MetaTree.NodeMouseClick += new TreeNodeMouseClickEventHandler(this.MetaTree_NodeMouseDoubleClick);
            this.metaTreeContext.Items.AddRange(new ToolStripItem[] { this.openMetaInSeperateTabToolStripMenuItem });
            this.metaTreeContext.Name = "metaTreeContext";
            this.metaTreeContext.Size = new Size(0x4f, 0x1a);
            this.openMetaInSeperateTabToolStripMenuItem.Name = "openMetaInSeperateTabToolStripMenuItem";
            this.openMetaInSeperateTabToolStripMenuItem.Size = new Size(0x4e, 0x16);
            this.MetaGrid.Dock = DockStyle.Fill;
            this.MetaGrid.HelpVisible = false;
            this.MetaGrid.Location = new Point(0, 0);
            this.MetaGrid.Name = "MetaGrid";
            this.MetaGrid.Size = new Size(0x146, 0x13b);
            this.MetaGrid.TabIndex = 3;
            this.sbspConvertContext.Items.AddRange(new ToolStripItem[] { this.convertSBSPCollisionToolStripMenuItem });
            this.sbspConvertContext.Name = "sbspConvertContext";
            this.sbspConvertContext.Size = new Size(0xc1, 0x1a);
            this.convertSBSPCollisionToolStripMenuItem.Name = "convertSBSPCollisionToolStripMenuItem";
            this.convertSBSPCollisionToolStripMenuItem.Size = new Size(0xc0, 0x16);
            this.convertSBSPCollisionToolStripMenuItem.Text = "Convert SBSP Collision";
            this.convertSBSPCollisionToolStripMenuItem.Click += new EventHandler(this.convertSBSPCollisionToolStripMenuItem_Click);
            this.collConvertContext.Items.AddRange(new ToolStripItem[] { this.toolStripMenuItem1 });
            this.collConvertContext.Name = "sbspConvertContext";
            this.collConvertContext.Size = new Size(0xc5, 0x1a);
            this.toolStripMenuItem1.Name = "toolStripMenuItem1";
            this.toolStripMenuItem1.Size = new Size(0xc4, 0x16);
            this.toolStripMenuItem1.Text = "Collision BSP Converter";
            this.toolStripMenuItem1.Click += new EventHandler(this.toolStripMenuItem1_Click);
            this.sandDockManager1.OwnerForm = this;
            this.leftSandDock.Controls.Add(this.dockControl1);
            this.leftSandDock.Dock = DockStyle.Left;
            this.leftSandDock.Guid = new Guid("6742e0cc-d014-418b-8144-1efdd7ecbbce");
            this.leftSandDock.LayoutSystem = new SplitLayoutSystem(250, 400, Orientation.Horizontal, new LayoutSystemBase[] { new ControlLayoutSystem(0x1e2, 0x1c9, new DockControl[] { this.dockControl1 }, this.dockControl1) });
            this.leftSandDock.Location = new Point(0, 0x16);
            this.leftSandDock.Manager = this.sandDockManager1;
            this.leftSandDock.Name = "leftSandDock";
            this.leftSandDock.Size = new Size(0x1e6, 0x1c9);
            this.leftSandDock.TabIndex = 9;
            this.dockControl1.Closable = false;
            this.dockControl1.Controls.Add(this.MetaTree);
            this.dockControl1.Guid = new Guid("18629e07-0e0b-4454-82cf-47fbc58d8ed8");
            this.dockControl1.Location = new Point(0, 0x12);
            this.dockControl1.Name = "dockControl1";
            this.dockControl1.Size = new Size(0x1e2, 0x1a0);
            this.dockControl1.TabIndex = 0;
            this.dockControl1.Text = "Tag List";
            this.rightSandDock.Dock = DockStyle.Right;
            this.rightSandDock.Guid = new Guid("a866c1c0-e45f-49de-9fcc-31fae92aec8a");
            this.rightSandDock.LayoutSystem = new SplitLayoutSystem(250, 400);
            this.rightSandDock.Location = new Point(0x336, 0x16);
            this.rightSandDock.Manager = this.sandDockManager1;
            this.rightSandDock.Name = "rightSandDock";
            this.rightSandDock.Size = new Size(0, 0x1c9);
            this.rightSandDock.TabIndex = 10;
            this.bottomSandDock.Controls.Add(this.dockControl2);
            this.bottomSandDock.Dock = DockStyle.Bottom;
            this.bottomSandDock.Guid = new Guid("da203205-5dee-4619-ad22-83bce50804d8");
            this.bottomSandDock.LayoutSystem = new SplitLayoutSystem(250, 400, Orientation.Vertical, new LayoutSystemBase[] { new ControlLayoutSystem(0x150, 0x70, new DockControl[] { this.dockControl2 }, this.dockControl2) });
            this.bottomSandDock.Location = new Point(0x1e6, 0x16b);
            this.bottomSandDock.Manager = this.sandDockManager1;
            this.bottomSandDock.Name = "bottomSandDock";
            this.bottomSandDock.Size = new Size(0x150, 0x74);
            this.bottomSandDock.TabIndex = 11;
            this.dockControl2.Controls.Add(this.richTextBox1);
            this.dockControl2.Guid = new Guid("3f2c154f-10ce-407a-8898-604f58eba16c");
            this.dockControl2.Location = new Point(0, 0x16);
            this.dockControl2.Name = "dockControl2";
            this.dockControl2.Size = new Size(0x150, 0x47);
            this.dockControl2.TabIndex = 0;
            this.dockControl2.Text = "Output";
            this.dockControl2.Closing += new CancelEventHandler(this.dockControl2_Closing);
            this.richTextBox1.Dock = DockStyle.Fill;
            this.richTextBox1.Location = new Point(0, 0);
            this.richTextBox1.Name = "richTextBox1";
            this.richTextBox1.Size = new Size(0x150, 0x47);
            this.richTextBox1.TabIndex = 0;
            this.richTextBox1.Text = "";
            this.topSandDock.Dock = DockStyle.Top;
            this.topSandDock.Guid = new Guid("882aea9d-03cb-4288-9e01-9fafe4cbb99a");
            this.topSandDock.LayoutSystem = new SplitLayoutSystem(250, 400);
            this.topSandDock.Location = new Point(0, 0x16);
            this.topSandDock.Manager = this.sandDockManager1;
            this.topSandDock.Name = "topSandDock";
            this.topSandDock.Size = new Size(0x336, 0);
            this.topSandDock.TabIndex = 12;
            this.menuBar1.Guid = new Guid("0c02ea9d-5adf-4d76-8c5b-26135e75bbf0");
            this.menuBar1.Items.AddRange(new ToolbarItemBase[] { this.menuBarItem1, this.menuBarItem2, this.menuBarItem3, this.menuBarItem4 });
            this.menuBar1.Location = new Point(0, 0);
            this.menuBar1.Name = "menuBar1";
            this.menuBar1.OwnerForm = this;
            this.menuBar1.Size = new Size(0x336, 0x16);
            this.menuBar1.TabIndex = 13;
            this.menuBar1.Text = "menuBar1";
            this.menuBarItem1.Items.AddRange(new ToolbarItemBase[] { this.menuButtonItem1 });
            this.menuBarItem1.Text = "&File";
            this.menuButtonItem1.Text = "Open";
            this.menuButtonItem1.Activate += new EventHandler(this.menuButtonItem1_Activate);
            this.menuBarItem2.Items.AddRange(new ToolbarItemBase[] { this.menuButtonItem2, this.menuButtonItem3, this.menuButtonItem4 });
            this.menuBarItem2.Text = "&Edit";
            this.menuButtonItem2.Text = "Settings";
            this.menuButtonItem2.Activate += new EventHandler(this.menuButtonItem2_Activate);
            this.menuButtonItem3.Text = "Load File In MetaGrid";
            this.menuButtonItem3.Visible = false;
            this.menuButtonItem3.Activate += new EventHandler(this.menuButtonItem3_Activate);
            this.menuButtonItem4.Text = "Compile Tag To File";
            this.menuButtonItem4.Visible = false;
            this.menuButtonItem4.Activate += new EventHandler(this.menuButtonItem4_Activate);
            this.menuBarItem3.Items.AddRange(new ToolbarItemBase[] { this.menuButtonItem6, this.menuButtonItem7 });
            this.menuBarItem3.Text = "Meta";
            this.menuButtonItem6.Text = "Save Meta";
            this.menuButtonItem6.Activate += new EventHandler(this.menuButtonItem6_Activate);
            this.menuButtonItem7.Items.AddRange(new ToolbarItemBase[] { this.menuButtonItem8, this.menuButtonItem9, this.menuButtonItem10, this.menuButtonItem11, this.menuButtonItem14 });
            this.menuButtonItem7.Text = "Decompile";
            this.menuButtonItem8.Text = "Decompile";
            this.menuButtonItem8.Activate += new EventHandler(this.menuButtonItem8_Activate);
            this.menuButtonItem9.Text = "Decompile &As";
            this.menuButtonItem9.Activate += new EventHandler(this.menuButtonItem9_Activate);
            this.menuButtonItem10.Text = "Decompile Recursively";
            this.menuButtonItem10.Activate += new EventHandler(this.menuButtonItem10_Activate);
            this.menuButtonItem11.Text = "Decompile And Compile Tag To File";
            this.menuButtonItem11.Activate += new EventHandler(this.menuButtonItem11_Activate);
            this.menuButtonItem14.Text = "Decompile Raw";
            this.menuButtonItem14.Visible = false;
            this.menuButtonItem14.Activate += new EventHandler(this.menuButtonItem14_Activate);
            this.menuBarItem4.Items.AddRange(new ToolbarItemBase[] { this.menuButtonItem12, this.menuButtonItem13, this.menuButtonItem5, this.menuButtonItem15, this.objectrelocator });
            this.menuBarItem4.Text = "Map";
            this.menuButtonItem12.Text = "Decompile";
            this.menuButtonItem12.Activate += new EventHandler(this.menuButtonItem12_Activate);
            this.menuButtonItem13.Text = "Rebuild";
            this.menuButtonItem13.Activate += new EventHandler(this.menuButtonItem13_Activate);
            this.menuButtonItem5.Text = "Sign";
            this.menuButtonItem5.Activate += new EventHandler(this.menuButtonItem5_Activate);
            this.menuButtonItem15.Text = "Builder";
            this.menuButtonItem15.Activate += new EventHandler(this.menuButtonItem15_Activate);
            this.objectrelocator.Text = "Object Relocator";
            this.objectrelocator.Activate += new EventHandler(this.objectrelocator_Activate);
            this.documentContainer1.Controls.Add(this.dockControl3);
            this.documentContainer1.Controls.Add(this.dockControl6);
            this.documentContainer1.Controls.Add(this.dockControl4);
            this.documentContainer1.Cursor = Cursors.Default;
            this.documentContainer1.Dock = DockStyle.None;
            this.documentContainer1.Guid = new Guid("71657012-486e-4e46-b472-8964af142a4e");
            this.documentContainer1.LayoutSystem = new SplitLayoutSystem(250, 400, Orientation.Horizontal, new LayoutSystemBase[] { new DocumentLayoutSystem(330, 0x153, new DockControl[] { this.dockControl3, this.dockControl6, this.dockControl4 }, this.dockControl3) });
            this.documentContainer1.Location = new Point(0x1e9, 0x16);
            this.documentContainer1.Manager = null;
            this.documentContainer1.Name = "documentContainer1";
            this.documentContainer1.Size = new Size(0x14c, 0x155);
            this.documentContainer1.TabIndex = 14;
            this.dockControl3.Closable = false;
            this.dockControl3.Controls.Add(this.MetaGrid);
            this.dockControl3.Guid = new Guid("1d1a39af-c032-476e-b6cd-4fdad7cf867e");
            this.dockControl3.Location = new Point(3, 0x17);
            this.dockControl3.Name = "dockControl3";
            this.dockControl3.Size = new Size(0x146, 0x13b);
            this.dockControl3.TabIndex = 0;
            this.dockControl3.Text = "Meta Grid";
            this.dockControl6.BorderStyle = TD.SandDock.Rendering.BorderStyle.SunkenThick;
            this.dockControl6.Closable = false;
            this.dockControl6.Guid = new Guid("6b7e624e-e3c8-44cf-a3ab-dcdc97fdaafd");
            this.dockControl6.Location = new Point(3, 0x17);
            this.dockControl6.Name = "dockControl6";
            this.dockControl6.Size = new Size(0x231, 0x13b);
            this.dockControl6.TabIndex = 3;
            this.dockControl6.Text = "Renderer";
            this.dockControl4.BorderStyle = TD.SandDock.Rendering.BorderStyle.Flat;
            this.dockControl4.Closable = false;
            this.dockControl4.Guid = new Guid("72ad99ab-92d3-4c75-a550-ef25528c97cd");
            this.dockControl4.Location = new Point(3, 0x17);
            this.dockControl4.Name = "dockControl4";
            this.dockControl4.Size = new Size(0x231, 0x13b);
            this.dockControl4.TabIndex = 1;
            this.dockControl4.Text = "Bitmap Viewer";
            this.statusStrip1.Location = new Point(0, 0x1df);
            this.statusStrip1.Name = "statusStrip1";
            this.statusStrip1.Size = new Size(0x336, 0x16);
            this.statusStrip1.TabIndex = 1;
            this.statusStrip1.Text = "statusStrip1";
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            base.ClientSize = new Size(0x336, 0x1f5);
            base.Controls.Add(this.documentContainer1);
            base.Controls.Add(this.bottomSandDock);
            base.Controls.Add(this.leftSandDock);
            base.Controls.Add(this.rightSandDock);
            base.Controls.Add(this.topSandDock);
            base.Controls.Add(this.statusStrip1);
            base.Controls.Add(this.menuBar1);
            base.FormBorderStyle = FormBorderStyle.FixedSingle;
            base.Name = "HaloForm";
            this.Text = "H2Core";
            this.metaTreeContext.ResumeLayout(false);
            this.sbspConvertContext.ResumeLayout(false);
            this.collConvertContext.ResumeLayout(false);
            this.leftSandDock.ResumeLayout(false);
            this.dockControl1.ResumeLayout(false);
            this.bottomSandDock.ResumeLayout(false);
            this.dockControl2.ResumeLayout(false);
            this.documentContainer1.ResumeLayout(false);
            this.dockControl3.ResumeLayout(false);
            this.dockControl4.ResumeLayout(false);
            base.ResumeLayout(false);
            base.PerformLayout();
        }

        private void menuButtonItem1_Activate(object sender, EventArgs e)
        {
            if (this.OpenHaloMapDialog.ShowDialog() != DialogResult.Cancel)
            {
                this.map = new Map(this.OpenHaloMapDialog.FileName);
                this.Text = this.map.Map_Header.MapName + " - " + this.map.FilePath;
                this.AddMetasToTreeview();
            }
        }

        private void menuButtonItem10_Activate(object sender, EventArgs e)
        {
            TagDecompiler.DecompileRecursive(this.selectedMeta, this.map, ProgramSettings.OverwriteExistingTags);
            MessageBox.Show("Done");
        }

        private void menuButtonItem11_Activate(object sender, EventArgs e)
        {
            TagCompiler.CompileMetaFromTagInterface(this.selectedMeta.Interface, this.selectedMeta.Offset, this.selectedMeta.Magic).SaveMetaToFile(@"C:\newcompiled.data");
        }

        private void menuButtonItem12_Activate(object sender, EventArgs e)
        {
            DateTime now = DateTime.Now;
            TagDecompiler.DecompileMap(this.map, ProgramSettings.OverwriteExistingTags);
            MessageBox.Show(((TimeSpan) (DateTime.Now - now)).ToString());
        }

        private void menuButtonItem13_Activate(object sender, EventArgs e)
        {
            new core.Rebuilder.Rebuilder(this.map).ShowDialog();
        }

        private void menuButtonItem14_Activate(object sender, EventArgs e)
        {
            if ((this.selectedMeta != null) && (this.selectedMeta.TagType != "mode"))
            {
                MessageBox.Show("Pick a model");
            }
            else
            {
                FolderBrowserDialog dialog = new FolderBrowserDialog();
                dialog.ShowDialog();
                mode chunk = (mode) this.selectedMeta.Interface.Header.GetChunk(0);
                foreach (mode.Part_Layout layout in chunk.Part.Chunks)
                {
                    EndianIO nio = new EndianIO(dialog.SelectedPath + @"\Original[" + layout.Chunk_Number.ToString() + "].data", EndianType.LittleEndian);
                    nio.Open();
                    nio.Out.BaseStream.SetLength(0L);
                    nio.Out.SeekTo(0);
                    nio.Out.Write(layout.Visual_Raw.MS.ToArray());
                    nio.Close();
                    layout.Visual_Raw.DecompileRawData();
                    layout.Visual_Raw.CompileRawData();
                    nio = new EndianIO(dialog.SelectedPath + @"\New[" + layout.Chunk_Number.ToString() + "].data", EndianType.LittleEndian);
                    nio.Open();
                    nio.Out.BaseStream.SetLength(0L);
                    nio.Out.SeekTo(0);
                    nio.Out.Write(layout.Visual_Raw.MS.ToArray());
                    nio.Close();
                }
            }
        }

        private void menuButtonItem15_Activate(object sender, EventArgs e)
        {
            new core.Builder.Builder(this.map).ShowDialog();
        }

        private void menuButtonItem2_Activate(object sender, EventArgs e)
        {
            this.ps.ShowDialog();
        }

        private void menuButtonItem3_Activate(object sender, EventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            if (dialog.ShowDialog() != DialogResult.Cancel)
            {
                DecompiledTagInterface interface2 = new DecompiledTagInterface(dialog.FileName, this.map.HaloVersion, false);
                this.MetaGrid.SelectedObject = interface2.Header;
            }
        }

        private void menuButtonItem4_Activate(object sender, EventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            if (dialog.ShowDialog() != DialogResult.Cancel)
            {
                DecompiledTagInterface metainterface = new DecompiledTagInterface(dialog.FileName, this.map.HaloVersion, false);
                TagCompiler.CompileMetaFromTagInterface(metainterface, this.selectedMeta.Offset, this.selectedMeta.Magic).SaveMetaToFile(@"C:\newcompiled.data");
            }
        }

        private void menuButtonItem5_Activate(object sender, EventArgs e)
        {
            this.map.Sign();
            MessageBox.Show("Done");
        }

        private void menuButtonItem6_Activate(object sender, EventArgs e)
        {
            this.selectedMeta.SaveMetaToFile(@"C:\newmeta.data");
        }

        private void menuButtonItem8_Activate(object sender, EventArgs e)
        {
            if (this.selectedMeta.TagType == "sbsp")
            {
                TagDecompiler.Decompile(this.selectedMeta, ProgramSettings.OverwriteExistingTags, this.map);
            }
            else
            {
                TagDecompiler.Decompile(this.selectedMeta, ProgramSettings.OverwriteExistingTags);
            }
            MessageBox.Show("Done");
        }

        private void menuButtonItem9_Activate(object sender, EventArgs e)
        {
            TagDecompiler.DecompileAs(this.selectedMeta);
        }

        private void MetaTree_NodeMouseDoubleClick(object sender, TreeNodeMouseClickEventArgs e)
        {
            string name = "";
            string type = "";
            switch (this.metatreedisplaytype)
            {
                case FormFunctions.MetaView.FolderView:
                    this.tagnumber = (int) e.Node.Tag;
                    break;

                case FormFunctions.MetaView.TagTypeView:
                    if ((e.Node != null) && (e.Node.Parent != null))
                    {
                        name = e.Node.Text;
                        type = e.Node.Parent.Text;
                        this.tagnumber = this.map.FindByNameAndTagType(type, name);
                        break;
                    }
                    this.tagnumber = -1;
                    break;
            }
            if (this.tagnumber == -1)
            {
                this.selectedMeta = null;
            }
            else
            {
                base.Enabled = false;
                this.selectedMeta = new Meta(this.tagnumber, ref this.map);
                if (this.selectedMeta.Interface != null)
                {
                    this.MetaGrid.SelectedObject = this.selectedMeta.Interface.Header;
                }
                base.Enabled = true;
            }
        }

        private void objectrelocator_Activate(object sender, EventArgs e)
        {
            new ObjectRelocator(this.map).ShowDialog();
        }

        private void toolStripMenuItem1_Click(object sender, EventArgs e)
        {
            new CollisionConverter(this.selectedMeta.Tag_Number, this.map).ShowDialog();
        }
    }
}

